unit EM.Forms.Main;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, Forms, Controls, Graphics, Dialogs, ExtCtrls, StdCtrls,
  ActnList, PairSplitter, ComCtrls;

type

{ TfrmMain }
  TfrmMain = class(TForm)
    alMain: TActionList;
    Edit1: TEdit;
    fpEmojis: TFlowPanel;
    gbEmojiInfo: TGroupBox;
    lblSearch: TLabel;
    lbCategories: TListBox;
    panEmojisAndInfo: TPanel;
    panSearchAndCategories: TPanel;
    edtSearch: TPanel;
    sbMain: TStatusBar;
    sbEmojis: TScrollBox;
    procedure FormCreate(Sender: TObject);
  private
    FLastEmoji: TLabel;

    procedure DisplayHint(Sender: TObject);
    procedure EmojiClick(Sender: TObject);
  public

  end;

var
  frmMain: TfrmMain;

implementation

uses
  LazUTF8
//, StrUtils
;

{$R *.lfm}

{ TfrmMain }

procedure TfrmMain.FormCreate(Sender: TObject);
var
  index: Integer;
  emoji: TLabel;
begin
  FLastEmoji:= nil;
  lbCategories.ItemIndex:= 0;
  for index:=0 to 79 do
  begin
    emoji:= TLabel.Create(fpEmojis);
    emoji.Parent:= fpEmojis;
    emoji.BorderSpacing.Top:= 4;
    emoji.BorderSpacing.Left:= 4;
    emoji.AutoSize:= True;
    emoji.Font.Size:= 30;
    emoji.Caption:= UnicodeToUTF8($1F600 + index);
    emoji.ParentShowHint:= False;
    emoji.ShowHint:= True;
    emoji.OnClick:= @EmojiClick;
    emoji.Hint:= IntToStr($1F600 + index) +
      '|This emoji ' + IntToStr($1F600 + index);
  end;
  Application.OnHint:= @DisplayHint;
end;

procedure TfrmMain.DisplayHint(Sender: TObject);
begin
  sbMain.SimpleText:= 'Name: ' + GetLongHint(Application.Hint);
end;

procedure TfrmMain.EmojiClick(Sender: TObject);
begin
  if not gbEmojiInfo.Visible then
    gbEmojiInfo.Visible:= True;
  if Assigned(FLastEmoji) then
  begin
    FLastEmoji.Color:= clNone;
  end;
  if Sender is TLabel then
  begin
    FLastEmoji:= TLabel(Sender);
    TLabel(Sender).Color:= clRed;
    gbEmojiInfo.Caption:= 'Info: ' +  GetShortHint(TLabel(Sender).Hint);
  end;
end;

end.

